package lpd

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestLDP(t *testing.T) {
	m := NewMatcher()

	conn, err := net.Dial("tcp", "192.168.1.99:515")
	if err != nil {
		t.Errorf("ERR %s", err)
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.99", 515)

	for i := 0; i < m.PacketCount(matchCtx); i++ {
		_, err := conn.Write(m.Packet(matchCtx, i).Buffer)
		if err != nil {
			t.Error(err)
		}
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(matchCtx, i, p); err != nil {
			t.Error(err)
		}
	}
	t.Log(m.Name(matchCtx))
	t.Log(matchCtx)

}
