package nbss

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestNBSS(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("tcp", "192.168.1.102:139")
	if err != nil {
		t.Errorf("ERR %s", err)
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.102", 139)

	for i := 0; i < m.PacketCount(matchCtx); i++ {

		pack := m.Packet(matchCtx, i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(matchCtx, 0, p); err != nil {
			t.Error(err)
		}
	}
	t.Log(m.Name(matchCtx))
	t.Log(matchCtx)
}
