package v2

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestSNMPv2(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("udp", "192.168.1.99:161")
	if err != nil {
		t.Error(err)
		return
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.99", 161)

	pack := m.Packet(matchCtx, 0)
	conn.Write(pack.Buffer)

	bytes := make([]byte, 1024)
	n, _ := conn.Read(bytes)
	p := osm.NewPacket(bytes, n)

	if err := m.Match(matchCtx, 0, p); err != nil {
		t.Error(err)
	}
	t.Log(matchCtx)
}
