package telnet

import (
	osm "git.loafle.net/overflow/service_matcher-go"

	"net"
	"testing"
)

func TestTelnetMatcher_Match(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("tcp", "192.168.1.201:23")
	if err != nil {
		t.Error(err)
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.201", 23)

	for i := 0; i < m.PacketCount(matchCtx); i++ {
		_, err := conn.Write(m.Packet(matchCtx, i).Buffer)
		if err != nil {
			t.Error(err)
		}
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(matchCtx, i, p); err != nil {
			t.Error(err)
			return
		}
	}
	t.Log(m.Name(matchCtx))
	t.Log(matchCtx)

}
